/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-1994, William Cheng.
 *
 * Permission limited to the use, copy, modify, and distribute this software
 * and its documentation for any purpose is hereby granted by the Author without
 * fee, provided that the above copyright notice appear in all copies and
 * that both the copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the Author not be used
 * in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.  All other
 * rights (including the right to sell "tgif" and the right to sell derivative
 * works of tgif) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /amnt/maui/tangram/u/william/X11/TGIF2/RCS/dup.e,v 2.16 1994/03/21 03:13:41 william Exp $
 */

#ifndef _DUP_E_
#define _DUP_E_

extern int	justDupped;
extern int	useRecentDupDistance;
extern int	dupDx;
extern int	dupDy;

extern void	CopyObjId ARGS_DECL((struct ObjRec *From, struct ObjRec *To));
extern void	CopyObjLocks ARGS_DECL((struct ObjRec *From,
		                        struct ObjRec *To));
extern void	UnlockAnObj ARGS_DECL((struct ObjRec *From));
extern void	DupObjBasics ARGS_DECL((struct ObjRec *From,
		                        struct ObjRec *To));
extern void	DupTextObj ARGS_DECL((struct TextRec *, struct ObjRec *));
extern struct ObjRec	* DupObj ARGS_DECL((struct ObjRec *));
extern void	DupSelObj ARGS_DECL((void));
extern void	DupTheseObjects ARGS_DECL((struct SelRec *Top,
		                           struct SelRec *Bot,
		                           struct SelRec **NewTop,
		                           struct SelRec **NewBot));
extern void	JustDupSelObj ARGS_DECL((struct SelRec **NewTop,
		                         struct SelRec **NewBot));

#endif /*_DUP_E_*/
